Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 2620)
@@ -4,81 +4,342 @@
    !! Ocean mesh    :  ???
    !!======================================================================
-   !! History :  OPA  !  07-1996  (O. Marti)  Original code
-   !!   NEMO     1.0  !  02-2008  (G. Madec)  F90: Free form
-   !!            3.0  !  
+   !! History :  OPA  ! 1989-07  (O. Marti)  Original code
+   !!   NEMO     1.0  ! 2002-08  (G. Madec)  F90: Free form + opt.
+   !!             -   ! 2006-02  (A. Caubel)  oce2geo - Original code
+   !!            2.0  ! 2007-04  (S. Masson)  Add T, F points and bugfix in cos lateral boundary
+   !!            3.0  ! 2008-07  (G. Madec)  geo2oce suppress lon/lat agruments
+   !!            3.3  ! 2010-10  (K. Mogensen) add obs_rot
+   !!            4.0  ! 2011-02  (G. Madec)  dynamical allocation + addition of angle_geo
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   repcmo      : 
-   !!   angle       :
-   !!   geo2oce     :
-   !!   repere      :   old routine suppress it ???
+   !!   angle_msh_geo    : local sin/cos of the angle between model grid lines and the North direction
+   !!   angle_geo        : local sin/cos of the latitude and longitude at each mesh grid point
+   !!   geo2oce, oce2geo : ?
+   !!   obs_rot          : provide to OBS operator the sin &cos at u- and v-points
+   !!
+   !!   repcmo, repere, rot_rep :   old routines  ==> to be suppressed
    !!----------------------------------------------------------------------
-   USE dom_oce         ! mesh and scale factors
-   USE phycst          ! physical constants
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE dom_oce        ! mesh and scale factors
+   USE phycst         ! physical constants
+   USE in_out_manager ! I/O manager
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   rot_rep, repcmo, repere, geo2oce, oce2geo   ! only rot_rep should be used
-                                             ! repcmo and repere are keep only for compatibility.
-                                             ! they are only a useless overlay of rot_rep
-
-   PUBLIC   obs_rot
-   PUBLIC   geo2oce_alloc ! Called in nemogcm.F90
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   &
-      gsint, gcost,   &  ! cos/sin between model grid lines and NP direction at T point
-      gsinu, gcosu,   &  ! cos/sin between model grid lines and NP direction at U point
-      gsinv, gcosv,   &  ! cos/sin between model grid lines and NP direction at V point
-      gsinf, gcosf       ! cos/sin between model grid lines and NP direction at F point
-
-   LOGICAL ::   lmust_init = .TRUE.        !: used to initialize the cos/sin variables (se above)
-
-   ! Local 'saved' arrays - one set for geo2oce and one set for oce2geo.
-   ! Declared here so can be allocated in ge2oce_alloc().
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zsinlon_o2g, zcoslon_o2g, zsinlat_o2g, zcoslat_o2g
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   zsinlon_g2o, zcoslon_g2o, zsinlat_g2o, zcoslat_g2o
+   PUBLIC   geo2oce, oce2geo   !    
+   PUBLIC   obs_rot            !
+   !
+   PUBLIC   repcmo, repere, rot_rep    ! CAUTION: these routines are kept only for compatibility.
+   !                                   !          They are only a useless overlay of rot_rep
+
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   gsin, gcos         ! sinus & cosinus at T,U,V,F points
+   !                                                                     ! between mesh and NP direction
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   gsinlon, gsinlat   ! sinus   of lon & lat at T,U,V,F points
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   gcoslon, gcoslat   ! cosinus of lon & lat at T,U,V,F points
 
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-   FUNCTION geo2oce_alloc()
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE geo2oce_alloc  ***
-      !!----------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: geo2oce_alloc
-
-      ALLOCATE(gsint(jpi,jpj), gcost(jpi,jpj),   &
-               gsinu(jpi,jpj), gcosu(jpi,jpj),   &
-               gsinv(jpi,jpj), gcosv(jpi,jpj),   &
-               gsinf(jpi,jpj), gcosf(jpi,jpj),   &
-               !
-               zsinlon_o2g(jpi,jpj,4), zcoslon_o2g(jpi,jpj,4), & 
-               zsinlat_o2g(jpi,jpj,4), zcoslat_o2g(jpi,jpj,4), &
-               zsinlon_g2o(jpi,jpj,4), zcoslon_g2o(jpi,jpj,4), &
-               zsinlat_g2o(jpi,jpj,4), zcoslat_g2o(jpi,jpj,4), &
-               Stat=geo2oce_alloc)
-
-   END FUNCTION geo2oce_alloc
-
-
-   SUBROUTINE repcmo ( pxu1, pyu1, pxv1, pyv1,   &
-                       px2 , py2 )
+   SUBROUTINE angle_msh_geo
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE angle_msh_geo  ***
+      !! 
+      !! ** Purpose :   Compute angles between model grid lines and the North direction
+      !!
+      !! ** Action  :   allocate and compute (gsint, gcost, gsinu, gcosu, gsinv, 
+      !!              gcosv, gsinf, gcosf) arrays: sinus and cosinus of the angle 
+      !!              between the north-south axe and the j-direction at t, u, v and f-points
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ji, jj   ! dummy loop indices
+      INTEGER  ::   ierr     ! local integer
+      REAL(wp) ::   zpi_4    ! local scalar (pi/4)
+      REAL(wp) ::   zlam, zphi, zlan, zphh   ! local scalars
+      REAL(wp) ::   zxnpt, zynpt, znnpt      ! x,y components & norm of the vector: T point to North Pole
+      REAL(wp) ::   zxnpu, zynpu, znnpu      ! x,y components & norm of the vector: U point to North Pole
+      REAL(wp) ::   zxnpv, zynpv, znnpv      ! x,y components & norm of the vector: V point to North Pole
+      REAL(wp) ::   zxnpf, zynpf, znnpf      ! x,y components & norm of the vector: F point to North Pole
+      REAL(wp) ::   zxvvt, zyvvt, znvvt      ! x,y components & norm of the vector: between V pts below and above a T pt
+      REAL(wp) ::   zxffu, zyffu, znffu      ! x,y components & norm of the vector: between F pts below and above a U pt
+      REAL(wp) ::   zxffv, zyffv, znffv      ! x,y components & norm of the vector: between F pts left  and right a V pt
+      REAL(wp) ::   zxuuf, zyuuf, znuuf      ! x,y components & norm of the vector: between U pts below and above a F pt
+      !!----------------------------------------------------------------------
+      !
+      ! already allocated & initialized  ==> return
+      ! -------------------------------
+      IF( ALLOCATED( gsin ) .AND. ALLOCATED( gcos )  )   RETURN
+
+      ! allocate cos & sin arrays 
+      ! -------------------------
+      ALLOCATE( gsin(jpi,jpj,4) , gcos(jpi,jpj,4) , STAT=ierr )
+      IF(lk_mpp)   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop('STOP', 'angle_msh_geo: unable to allocate arrays' )
+      !
+      ! initialize cos & sin arrays
+      ! ----------------------------
+      ! (computation done on the north stereographic polar plane)
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' angle_msh_geo : geographic <--> model mesh , cos/sin initialization '
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+      zpi_4 = rpi / 4._wp
+      !
+      DO jj = 2, jpjm1
+!CDIR NOVERRCHK
+         DO ji = fs_2, jpi   ! vector opt.
+            !
+            zlam = glamt(ji,jj)            ! north pole direction & modulous (at t-point)
+            zphi = gphit(ji,jj)
+            zxnpt = 0._wp - 2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            zynpt = 0._wp - 2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            znnpt = zxnpt*zxnpt + zynpt*zynpt
+
+            zlam = glamu(ji,jj)            ! north pole direction & modulous (at u-point)
+            zphi = gphiu(ji,jj)
+            zxnpu = 0._wp - 2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            zynpu = 0._wp - 2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            znnpu = zxnpu*zxnpu + zynpu*zynpu
+
+            zlam = glamv(ji,jj)            ! north pole direction & modulous (at v-point)
+            zphi = gphiv(ji,jj)
+            zxnpv = 0._wp - 2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            zynpv = 0._wp - 2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            znnpv = zxnpv*zxnpv + zynpv*zynpv
+            
+            zlam = glamf(ji,jj)            ! north pole direction & modulous (at f-point)
+            zphi = gphif(ji,jj)
+            zxnpf = 0._wp - 2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            zynpf = 0._wp - 2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )
+            znnpf = zxnpf*zxnpf + zynpf*zynpf
+
+            zlam = glamv(ji,jj  )            ! j-direction: v-point segment direction (around t-point)
+            zphi = gphiv(ji,jj  )
+            zlan = glamv(ji,jj-1)
+            zphh = gphiv(ji,jj-1)
+            zxvvt =  2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * COS( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            zyvvt =  2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * SIN( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            znvvt = SQRT( znnpt * ( zxvvt*zxvvt + zyvvt*zyvvt )  )
+            znvvt = MAX( znvvt, 1.e-14 )
+
+            zlam = glamf(ji,jj  )            ! j-direction: f-point segment direction (around u-point)
+            zphi = gphif(ji,jj  )
+            zlan = glamf(ji,jj-1)
+            zphh = gphif(ji,jj-1)
+            zxffu =  2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * COS( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            zyffu =  2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * SIN( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            znffu = SQRT( znnpu * ( zxffu*zxffu + zyffu*zyffu )  )
+            znffu = MAX( znffu, 1.e-14 )
+
+            zlam = glamf(ji  ,jj)            ! i-direction: f-point segment direction (around v-point)
+            zphi = gphif(ji  ,jj)
+            zlan = glamf(ji-1,jj)
+            zphh = gphif(ji-1,jj)
+            zxffv =  2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * COS( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            zyffv =  2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * SIN( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            znffv = SQRT( znnpv * ( zxffv*zxffv + zyffv*zyffv )  )
+            znffv = MAX( znffv, 1.e-14 )
+
+            zlam = glamu(ji,jj+1)            ! j-direction: u-point segment direction (around f-point)
+            zphi = gphiu(ji,jj+1)
+            zlan = glamu(ji,jj  )
+            zphh = gphiu(ji,jj  )
+            zxuuf =  2._wp * COS( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * COS( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            zyuuf =  2._wp * SIN( rad*zlam ) * TAN( zpi_4 - rad*zphi*0.5 )   &
+               &  -  2._wp * SIN( rad*zlan ) * TAN( zpi_4 - rad*zphh*0.5 )
+            znuuf = SQRT( znnpf * ( zxuuf*zxuuf + zyuuf*zyuuf )  )
+            znuuf = MAX( znuuf, 1.e-14 )
+
+            ! cosinus and sinus using scalar and vectorial products
+            gsin(ji,jj,1) = ( zxnpt*zyvvt - zynpt*zxvvt ) / znvvt      ! T-point
+            gcos(ji,jj,1) = ( zxnpt*zxvvt + zynpt*zyvvt ) / znvvt
+
+            gsin(ji,jj,2) = ( zxnpu*zyffu - zynpu*zxffu ) / znffu      ! U-point
+            gcos(ji,jj,2) = ( zxnpu*zxffu + zynpu*zyffu ) / znffu
+            !
+            gsin(ji,jj,3) = ( zxnpv*zxffv + zynpv*zyffv ) / znffv        ! F-point
+            gcos(ji,jj,3) =-( zxnpv*zyffv - zynpv*zxffv ) / znffv            ! (caution, rotation of 90 degres)
+            !
+            gsin(ji,jj,4) = ( zxnpf*zyuuf - zynpf*zxuuf ) / znuuf      ! V-point
+            gcos(ji,jj,4) = ( zxnpf*zxuuf + zynpf*zyuuf ) / znuuf
+            !
+         END DO
+      END DO
+      !
+      ! Geographic mesh case
+      ! --------------------
+      DO jj = 2, jpjm1
+         DO ji = fs_2, jpi   ! vector opt.
+            IF( MOD( ABS( glamv(ji,jj) - glamv(ji,jj-1) ), 360. ) < 1.e-8 ) THEN
+               gsin(ji,jj,1) = 0.
+               gcos(ji,jj,1) = 1.
+            ENDIF
+            IF( MOD( ABS( glamf(ji,jj) - glamf(ji,jj-1) ), 360. ) < 1.e-8 ) THEN
+               gsin(ji,jj,2) = 0.
+               gcos(ji,jj,2) = 1.
+            ENDIF
+            IF(      ABS( gphif(ji,jj) - gphif(ji-1,jj) )         < 1.e-8 ) THEN
+               gsin(ji,jj,3) = 0.
+               gcos(ji,jj,3) = 1.
+            ENDIF
+            IF( MOD( ABS( glamu(ji,jj) - glamu(ji,jj+1) ), 360. ) < 1.e-8 ) THEN
+               gsin(ji,jj,4) = 0.
+               gcos(ji,jj,4) = 1.
+            ENDIF
+         END DO
+      END DO
+      !
+      CALL lbc_lnk( gcos(:,:,1), 'T', -1. )   ;   CALL lbc_lnk( gsin(:,:,1), 'T', -1. )      ! lateral boundary cond.
+      CALL lbc_lnk( gcos(:,:,2), 'U', -1. )   ;   CALL lbc_lnk( gsin(:,:,2), 'U', -1. )
+      CALL lbc_lnk( gcos(:,:,3), 'V', -1. )   ;   CALL lbc_lnk( gsin(:,:,3), 'V', -1. )
+      CALL lbc_lnk( gcos(:,:,4), 'F', -1. )   ;   CALL lbc_lnk( gsin(:,:,4), 'F', -1. )
+      !
+   END SUBROUTINE angle_msh_geo
+
+
+   SUBROUTINE angle_geo
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE angle_geo  ***
+      !!      
+      !! ** Purpose :   compute one for all, and at each mesh grid points, 
+      !!              the local cos/sin of latitude/longitude.
+      !!----------------------------------------------------------------------
+      INTEGER ierr
+      !!----------------------------------------------------------------------
+      !
+      IF( ALLOCATED( gsinlon ) .AND. ALLOCATED( gcoslon ) .AND.   &   !==  already allocated & initialized
+          ALLOCATED( gsinlat ) .AND. ALLOCATED( gcoslat )         )   RETURN
+
+      ALLOCATE( gsinlon(jpi,jpj,4) , gcoslon(jpi,jpj,4) ,     &       !==  allocate the arrays
+         &      gsinlat(jpi,jpj,4) , gcoslat(jpi,jpj,4) , STAT=ierr )
+      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'angle_geo: unable to allocate arrays')
+         !
+      gsinlon(:,:,1) = SIN( rad * glamt(:,:) )     ! T-point
+      gcoslon(:,:,1) = COS( rad * glamt(:,:) )
+      gsinlat(:,:,1) = SIN( rad * gphit(:,:) )
+      gcoslat(:,:,1) = COS( rad * gphit(:,:) )
+      !
+      gsinlon(:,:,2) = SIN( rad * glamu(:,:) )     ! U-point
+      gcoslon(:,:,2) = COS( rad * glamu(:,:) )
+      gsinlat(:,:,2) = SIN( rad * gphiu(:,:) )
+      gcoslat(:,:,2) = COS( rad * gphiu(:,:) )
+      !
+      gsinlon(:,:,3) = SIN( rad * glamv(:,:) )     ! V-point
+      gcoslon(:,:,3) = COS( rad * glamv(:,:) )
+      gsinlat(:,:,3) = SIN( rad * gphiv(:,:) )
+      gcoslat(:,:,3) = COS( rad * gphiv(:,:) )
+      !
+      gsinlon(:,:,4) = SIN( rad * glamf(:,:) )     ! T-point
+      gcoslon(:,:,4) = COS( rad * glamf(:,:) )
+      gsinlat(:,:,4) = SIN( rad * gphif(:,:) )
+      gcoslat(:,:,4) = COS( rad * gphif(:,:) )
+      !
+   END SUBROUTINE angle_geo
+
+
+   SUBROUTINE geo2oce( pxx, pyy, pzz, cgrid, pte, ptn )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE geo2oce  ***
+      !!      
+      !! ** Purpose :   Change a vector from geocentric to east/north
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   pxx, pyy, pzz   !
+      CHARACTER(len=1)            , INTENT(in   ) ::   cgrid           ! type of grid point
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) ::   pte, ptn        !
+      !!
+      INTEGER ::   ipt     ! local integer
+      !!----------------------------------------------------------------------
+
+      CALL angle_geo             ! initialization of coc & sin (just a return if not the 1st call)
+      !
+      SELECT CASE (cgrid)        ! type of point
+      CASE ('T')   ;   ipt = 1
+      CASE ('U')   ;   ipt = 2
+      CASE ('V')   ;   ipt = 3
+      CASE ('F')   ;   ipt = 4
+      CASE DEFAULT   ;   CALL ctl_stop( 'Only T, U, V and F grid points are coded' )
+      END SELECT
+  
+      !                          ! transformation
+      pte(:,:) = - gsinlon(:,:,ipt)                    * pxx(:,:) + gcoslon(:,:,ipt) * pyy(:,:)
+      ptn(:,:) = - gsinlat(:,:,ipt) * gsinlat(:,:,ipt) * pxx(:,:)    &
+         &       - gsinlon(:,:,ipt) * gsinlat(:,:,ipt) * pyy(:,:) + gcoslat(:,:,ipt) * pzz(:,:)
+!!$   ptv(:,:) =   gsinlat(:,:,ipt) * gcoslat(:,:,ipt) * pxx(:,:)    &
+!!$              + zsinlon(:,:,ipt) * gcoslat(:,:,ipt) * pyy(:,:) + gsinlat(:,:,ipt) * pzz(:,:)
+      !
+   END SUBROUTINE geo2oce
+
+
+   SUBROUTINE oce2geo ( pte, ptn, cgrid, pxx , pyy , pzz )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE oce2geo  ***
+      !!      
+      !! ** Purpose :   Change vector from east/north to geocentric
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::  pte, ptn          ! 
+      CHARACTER(len=1)        , INTENT(in   ) ::  cgrid             !
+      REAL(wp), DIMENSION(:,:), INTENT(  out) ::  pxx , pyy , pzz   !
+      !!
+      INTEGER ::   ipt     !
+      !!----------------------------------------------------------------------
+      !
+      CALL angle_geo             ! initialization of coc & sin (just a return if not the 1st call)
+      !
+      SELECT CASE (cgrid)        ! type of point
+      CASE ('T')   ;   ipt = 1
+      CASE ('U')   ;   ipt = 2
+      CASE ('V')   ;   ipt = 3
+      CASE ('F')   ;   ipt = 4
+      CASE DEFAULT   ;   CALL ctl_stop( 'Only T, U, V and F grid points are coded' )
+      END SELECT
+      !
+      !                          ! transformation
+      pxx(:,:) = - gsinlon(:,:,ipt) * pte(:,:) - gcoslon(:,:,ipt) * gsinlat(:,:,ipt) * ptn(:,:) 
+      pyy(:,:) =   gcoslon(:,:,ipt) * pte(:,:) - gsinlon(:,:,ipt) * gsinlat(:,:,ipt) * ptn(:,:)
+      pzz(:,:) =   gcoslat(:,:,ipt) * ptn(:,:)
+      !
+   END SUBROUTINE oce2geo
+
+
+   SUBROUTINE obs_rot( psinu, pcosu, psinv, pcosv )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE obs_rot  ***
+      !!
+      !! ** Purpose :   provide to OBS operator the sin &cos at u- and v-points
+      !!              in order to rotate currents at observation points
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(out)::   psinu, pcosu, psinv, pcosv   ! copy of data
+      !!----------------------------------------------------------------------
+      !
+      CALL angle_msh_geo      ! initialization of coc & sin (just a return if not the 1st call)
+      !
+      psinu(:,:) = gsin(:,:,2)      ! U-point
+      pcosu(:,:) = gcos(:,:,2)
+      psinv(:,:) = gsin(:,:,3)      ! V-point
+      pcosv(:,:) = gcos(:,:,3)
+      !
+   END SUBROUTINE obs_rot
+
+
+   SUBROUTINE repcmo( pxu1, pyu1, pxv1, pyv1, px2 , py2 )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE repcmo  ***
       !!
       !! ** Purpose :   Change vector componantes from a geographic grid to a
-      !!      stretched coordinates grid.
+      !!              stretched coordinates grid.
       !!
       !! ** Method  :   Initialization of arrays at the first call.
